/*
 * linux/arch/arm/mach-davinci/serial_davinci.c
 *
 * TI DaVinci serial driver hookup file
 *
 * Copyright (C) 2004 Texas Instruments.
 *
 * ----------------------------------------------------------------------------
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * ----------------------------------------------------------------------------
 Modifications:
 ver. 1.0: Oct 2005, Swaminathan S
 -
 *
 */

#include <linux/config.h>
#include <linux/module.h>
#include <linux/tty.h>
#include <linux/ioport.h>
#include <linux/init.h>
#include <linux/console.h>
#include <linux/serial_core.h>
#include <linux/serial.h>

#include <asm/io.h>
#include <asm/irq.h>
#include <asm/hardware.h>
#include <asm/serial.h>
#include <asm/arch/hardware.h>
#include <asm/arch/irqs.h>

static struct uart_port davinci_serialport = {
	.membase  = (unsigned char __iomem *)IO_ADDRESS(DAVINCI_UART0_BASE),
	.iotype   = UPIO_MEM,
	.irq      = IRQ_UARTINT0,
	.uartclk  = 27000000,
	.regshift = 2,
	.flags    = UPF_BOOT_AUTOCONF
};

/*
 * Just setup the initial console rest is taken care by the
 * Linux 8250 serial driver
 */
void davinci_serial_init(void)
{
#ifdef CONFIG_SERIAL_8250
	early_serial_setup(&davinci_serialport);
#endif
}
